// ArithEx7.java

import ch.aplu.util.*;

class ArithEx7
{
  ArithEx7()
  {
    byte b = (byte)0x81;
    int k = b > 0 ? b : 256 + b;
    System.out.println(k);

    int[] u = new int[4]; // Unsigned bytes
    u[0] = 0x80;
    u[1] = 0x04;
    u[2] = 0x02;
    u[3] = 0x01;

    long result = 0; // Unsigned int
    for (int i = 0; i < 4; i++)
      result = (result << 8) | u[i];
    System.out.println(result);

    long r = twoPow(31) + twoPow(18) + twoPow(9) + twoPow(0);
    System.out.println(r);
  }

  long twoPow(long n)
  {
    long y = 1;
    for (int i = 0; i < n; i++)
      y = 2 * y;
    return y;
  }

  public static void main(String[] args)
  {
    Console.init();
    new ArithEx7();
  }
}
