// EnumEx1.java

import static ch.aplu.util.Console.*;

class EnumEx1
{
  // Es werden 4 Objekte, naemlich die 4 Jahreszeiten erzeugt
  // Deklaration darf sich nicht in einer Methode befinden
  private enum Jahreszeiten {FRUEHLING, SOMMER, HERBST, WINTER};

  EnumEx1()
  {
    int zufallszahl = (int)(4 * Math.random()); // zufaellig 0, 1, 2, 3
    // values() liefert einen Array mit den Refs zu allen Jahreszeiten
    // Referenz zu einer zuflligen Jahreszeit:
    Jahreszeiten jahreszeit = Jahreszeiten.values()[zufallszahl];

    // switch
    switch(jahreszeit)
    {
      case FRUEHLING:
        println("sanfter Fruehlingswind");
        break;

      case SOMMER:
        println("Flimmernde Sommerhitze");
        break;

      case HERBST:
        println("Farbiges Herbstlaub");
        break;

      case WINTER:
        println("Verschneite Winterlandschaft");
        break;
    }

    // Vergleich mit ==
    if ( jahreszeit == Jahreszeiten.WINTER)
      println("ich gehe skilaufen");
    else
      println("ich gehe baden");

    // Indexwert, hier 0,1,2,3
    println("Index: " + jahreszeit.ordinal());

    // Vergleich mit compareTo(): Differenz der Indexwerte
    println("compareTo ... WINTER:" + jahreszeit.compareTo(Jahreszeiten.WINTER));

    // Durchlaufen aller Werte
    println("Die Jahrezeiten sind:");
    for (Jahreszeiten jz : Jahreszeiten.values())
    {
      print(jz.name());  // Oder jz.toString() oder nur jz
      if (jz == Jahreszeiten.HERBST)
        println(" (Farbiges Herbstlaub)");
      else
        println();
    }
  }

  public static void main(String[] args)
  {
    new EnumEx1();
  }
}
