// ConcreteFactory.java

package watch;

import java.util.*;

final class ConcreteFactory extends WatchFactory
{
  private long time;

  ConcreteFactory() // Package access only
  {
    time = -1; // Stopped
  }

  public void start()
  {
    time = new Date().getTime();
  }

  public long show()
  {
    if (time == -1)
      return -1; // Stopped
    return new Date().getTime() - time;
  }
}
