// EventTurtleEx1.java

import ch.aplu.turtle.*;
import java.awt.*;
import java.awt.event.*;

public class EventTurtleEx1
{
  private Turtle ann = new Turtle();

  public EventTurtleEx1()
  {
    ann.addKeyListener(new KeyAdapter()
    {
      public void keyPressed(KeyEvent evt)
      {
        int step = 10;
        int keyCode = evt.getKeyCode();
        switch (keyCode)
        {
          case KeyEvent.VK_LEFT :
            ann.setHeading(-90);
            ann.forward(step);
            break;

          case KeyEvent.VK_RIGHT :
            ann.setHeading(90);
            ann.forward(step);
            break;

          case KeyEvent.VK_UP :
            ann.setHeading(0);
            ann.forward(step);
            break;

          case KeyEvent.VK_DOWN :
            ann.setHeading(180);
            ann.forward(step);
            break;
        }
      }
    });

    ann.addMouseListener(new MouseAdapter()
    {
      public void mousePressed(MouseEvent evt)
      {
        ann.setScreenPos(evt.getPoint());
      }
    });

    ann.addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent evt)
      {
        ann.beep();
      }
    });

    ann.hideTurtle();
    ann.setColor(Color.red);
    ann.setFontSize(10);
    ann.setPos(-180, 150);
    ann.label("   Use cursor keys to move me around " +
              "and mouse clicks to make me jump.");
    ann.setPos(-180, 130);
    ann.label("   I ring the bell when quitting.");
    ann.home();
    ann.showTurtle();
  }

  public static void main(String[] args)
  {
    new EventTurtleEx1();
  }

}
