// TimedExit.java
// Terminate application after a certain time of inactivity

import java.awt.event.*;
import ch.aplu.util.*;

public class TimedExit extends GPanel implements TimerListener
{
  private final long timeout = 10000000; // 10s
  private LoResAlarmTimer timer = new LoResAlarmTimer(timeout,
                                    true);
  public TimedExit()
  {
    timer.addTimerListener(this);
    text("Click mouse to create a circle");
    addMouseListener(new MouseAdapter()
    {
      public void mousePressed(MouseEvent evt)
      {
        move(toWindow(evt.getPoint()));
        fillCircle(0.01);
        timer.start();
      }
    });

    // This while loop only serves to display the remaining time to live.
    // It may be omitted.
    while (true)
    {
      title("Time to live: " +
            (int)Math.ceil(timer.getTime() / 1000000.0));
      try
      {
        Thread.currentThread().sleep(100);
      }
      catch (InterruptedException ex) {}
    }

  }

  public boolean timeElapsed()
  {
    System.exit(0);
    return false;
  }

  public static void main(String[] args)
  {
    new TimedExit();
  }
}



