// SimEx1.java

import static ch.aplu.util.Console.*;

class SimEx1
{
  public static void main(String[] args)
  {
    setTitle("Vertikaler Wurf. Vergleich mit Theorie");

    final double g = 9.81; // Erdbeschleunigung im m/s^2
    final double d = 0.1;  // Zeitschritt in s
    final double x0 = 0;   // Anfangskoordinate in m
    final double v0 = 20;  // Anfangsgeschwindigkeit in m/s

    double a = -g;                 // Beschleunigung
    double t = 0, x = x0, v = v0;  // Anfangsbedingungen
    double xt = 0, vt = v0;        // Theoretische Werte

    printf("%10s %10s %10s %10s %10s%n",
           "t", "x", "v", "xt", "vt");

    while ( t < 10 )
    {
      printf("%10.1f %10.2f %10.2f %10.2f %10.2f%n",
             t, x, v, xt, vt);
      x = x + v*d;  // Neue Koordinate
      v = v + a*d;  // Neue Geschwindigkeit
      t = t + d;    // Neue Zeit

      xt = v0*t - 0.5*g*t*t;   // Theoretische Koordinate
      vt = v0 - g*t;           // Theoretische Geschwindigkeit
    }
  }
}