// WindowEx5.java
// For pre J2SE 1.5 versions:
// Because of HiResAlarmTimer, Java3D must be installed


import ch.aplu.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;

public class WindowEx5 extends JPanel
{
  private GWindow w = new GWindow("Pendelschwingung",
                                  new Size(401, 401));

  public WindowEx5()
  {
    w.showComponent(this);
    Pendulum pend = new Pendulum(w.getOffG2D(),
                                 new Spring(140, 7, 10),
                                 new Mass(20),
                                 new Point(200, 50));
    oscillate(pend);
  }

  private void oscillate(Pendulum pend)
  {
    double period = 4; // sec
    double dt = 0.01; // sec
    double t;
    double amplitude = 50;

    HiResAlarmTimer timer =
      new HiResAlarmTimer((long)(1000000 * dt));

    while (true)
    {
      for (t = 0; t <= period; t += dt)
      {
        int extension = (int)(amplitude *
                              Math.sin(2 * Math.PI / period *
                                       t));
        pend.show(extension);
        repaint();
        while (timer.isRunning()) {}
        timer.start();
        w.clearBuf();
      }
    }
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    BufferedImage bi = w.getBufferedImage();
    Graphics2D g2D = (Graphics2D)g;
    g2D.drawImage(bi, 0, 0, this);
  }

  public static void main(String[] args)
  {
    new WindowEx5();
  }
}
