// Pendulum.java

import java.awt.*;
import java.awt.geom.*;

public class Pendulum
{
  private Graphics2D g2D;
  private Spring spring;
  private Mass mass;
  private Point anchor;

  public Pendulum(Graphics2D g2D, Spring spring, Mass mass,
                  Point anchor)
  {
    this.g2D = g2D;
    this.spring = spring;
    this.mass = mass;
    this.anchor = anchor;
  }

  public void show(int extension)
  {
    g2D.fill(new Rectangle2D.Double(anchor.x - 70,
                                    anchor.y - 20, 140, 20));
    spring.show(g2D, anchor, extension);
    mass.show(g2D,
              new Point(anchor.x,
                        anchor.y + spring.getLength() +
                        extension));
  }
}
