// Spring.java

import java.awt.*;
import java.awt.geom.*;

public class Spring
{
  private int length;
  private GeneralPath gp = new GeneralPath();

  public Spring(int length, int nbTurns, int diameter)
  {
    this.length = length;
    float dm = (float)diameter;
    float ht = (float)length / nbTurns;
    gp.moveTo(0, 0);
    for (int i = 0; i < nbTurns; i++)
    {
      gp.lineTo(dm, i * ht + ht / 4);
      gp.lineTo(-dm, i * ht + 3 * ht / 4);
      gp.lineTo(0, (i + 1) * ht);
    }
  }

  public int getLength()
  {
    return length;
  }

  public void show(Graphics2D g2D, Point anchor,
                   int extension)
  {
    GeneralPath currentPath = (GeneralPath)gp.clone();
    double xScale = 1;
    double yScale = (double)(length + extension) / length;
    AffineTransform t = new AffineTransform();
    t.scale(xScale, yScale);
    t.translate(anchor.x / xScale, anchor.y / yScale);
    currentPath.transform(t);
    BasicStroke stroke = new BasicStroke(2);
    g2D.setStroke(stroke);

    g2D.draw(currentPath);
  }
}
