// MatrixEx1.java

import Jama.*;
import ch.aplu.util.*;

public class MatrixEx1 extends Console
{
  public MatrixEx1()
  {
    double[][] vals = {
        {1.0, 2.0, 3.0},
        {1.0, 3.0, 5.0},
        {1.0, 4.0, 6.0} };

    Matrix A = new Matrix(vals);
    Matrix B = Matrix.random(3, 3);

    println("Demonstration of matrix package Jama");
    println("Matrix A = ");
    A.print(12, 2);
    println("Matrix B = ");
    B.print(12, 2);

    println("Press any key to continue...");
    getKeyWait();
    println("Matrix C = A + B");
    Matrix C = A.plus(B);
    C.print(12, 2);

    println("Press any key to continue..."); getKeyWait();
    println("Matrix C = A - B");
    C = A.minus(B);
    C.print(12, 2);

    println("Press any key to continue..."); getKeyWait();
    println("Matrix B = inverse(A)");
    B = A.inverse();
    B.print(12, 2);

    println("Press any key to continue..."); getKeyWait();
    println("Matrix C = A * B");
    C = A.times(B);
    C.print(12, 2);

    println("Press any key to continue..."); getKeyWait();
    println("Vector z");
    Matrix b = new Matrix(3, 1);
    b.set(0, 0, 10);
    b.set(1, 0, 20);
    b.set(2, 0, 30);
    b.print(12, 2);

    println("Press any key to continue..."); getKeyWait();
    println("Solve x from A * x = b");
    Matrix x = A.solve(b);
    x.print(12, 2);

    println("Press any key to quit");
    getKeyWait();
    System.exit(0);
  }

  public static void main(String[] args)
  {
    new MatrixEx1();
  }
}