// Conform.java
// Angle conserving transformation of regular grid

import ORG.netlib.math.complex.Complex;
import ch.aplu.util.*;
import java.awt.Color;

public class Conform
{
  private double min = -5;
  private double max = 5;
  private double step = (max - min) / 400.0;
  private Complex reStep = new Complex(step, 0);
  private Complex imStep = new Complex(0, step);
  private GPanel p = new GPanel(min, max, min, max);

  public Conform()
  {
    p.line(min, 0, max, 0); // Real axis
    p.line(0, min, 0, max); // Imaginary axis
    p.enableRepaint(false);
    transform();
  }

  private void transform()
  {
    // Transform horizontal grid lines
    p.color(Color.green);
    Complex z = new Complex(min, min);
    while (z.im() < max)
    {
      z = new Complex(min, z.im());
      cmove(f(z));
      while (z.re() < max)
      {
        cdraw(f(z));
        z = z.add(reStep);
      }
      z = z.add(imStep);
      p.repaint();
    }

    // Transform vertical grid lines
    p.color(Color.red);
    z = new Complex(min, min);
    while (z.re() < max)
    {
      z = new Complex(z.re(), min);
      cmove(f(z));
      while (z.im() < max)
      {
        cdraw(f(z));
        z = z.add(imStep);
      }
      z = z.add(reStep);
      p.repaint();
    }
  }

  private Complex f(Complex z)

  // function f(z) = 1/z
  {
    if (z.abs() != 0)
      return Complex.real(1).div(z);
    else
      return Complex.real(0);
  }

  private void cmove(Complex z)
  {
    p.move(z.re(), z.im());
  }

  private void cdraw(Complex z)
  {
    p.draw(z.re(), z.im());
  }

  public static void main(String[] args)
  {
    new Conform();
  }
}
