// MatrixEx3a.java
// Like Matrix3a, without exception handling

import Jama.*;
import ch.aplu.util.Console;
import java.io.*;

public class MatrixEx3a extends Console
{
  public MatrixEx3a() throws Exception
  {
    double[][] vals = {
        {1.0, 2.0, 3.0},
        {1.0, 3.0, 5.0},
        {1.0, 4.0, 6.0} };

    Matrix A = new Matrix(vals);
    Matrix Ainv = A.inverse();
    println("Matrix A = ");
    A.print(12, 2);
    println("Matrix Ainv = ");
    Ainv.print(12, 2);

    // Save matrices
    println("Press any key to save matrices...");
    getKeyWait();

    File file = new File("matrix.dat");

    ObjectOutputStream out =
      new ObjectOutputStream(new FileOutputStream(file));
    out.writeObject(A);
    out.writeObject(Ainv);
    out.close();
    println("File " + file.getPath() + " successfully created.");

    // Restore matrices
    println("Press any key to restore matrices and perform operation...");
    getKeyWait();
    ObjectInputStream in =
      new ObjectInputStream(new FileInputStream(file));
    Matrix X = (Matrix)in.readObject();
    Matrix Y = (Matrix)in.readObject();
    in.close();

    Matrix Z = X.times(Y);
    println("Matrix X = ");
    X.print(12, 2);
    println("Matrix Y = ");
    Y.print(12, 2);
    println("Matrix Z = X*Y = ");
    Z.print(12, 2);
    println("Press any key to quit...");
    getKeyWait();
    System.exit(0);
  }

  public static void main(String[] args) throws Exception
  {
    new MatrixEx3a();
  }
}