// MatrixEx4.java
// Read matrix from Excel xls-file
// Excel sheet named matrix_1 holds the data in line 2, 3, 4
// ODBC User DSN named "matrix" must be created using Excel driver
// and specifying the xls-file

import Jama.*;
import ch.aplu.util.*;
import java.sql.*;

public class MatrixEx4 extends Console
{
  final int n = 3;  // Size of matrix
  final String ODBC_DSN = "matrix";
  final String sheetname = "matrix_1";

  public MatrixEx4()
  {
    Matrix A = new Matrix(n, n);
    Connection con = null;

    println("Reading matrix from Excel file now...");

    // Load ODBC driver
    try
    {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    catch (ClassNotFoundException ex)
    {
      println("Fatal error. Exception while loading ODBC driver");
      println("Press any key to quit...");
      getKeyWait();
      System.exit(1);
    }

    // Read data
    try
    {
      con = DriverManager.getConnection("jdbc:odbc:" + ODBC_DSN);
      Statement stmt = con.createStatement();
      String sql = "select * from [" + sheetname + "$]";
       // Will throw an exception, if Excel data sheet does not exist
      ResultSet rs = stmt.executeQuery(sql);

      int i = 0;
      while (rs.next()) // Loose first line in Excel table
      {
        for (int k = 0; k < n; k++)
        {
//          String columnValue = rs.getString(i);
          double value  = rs.getDouble(k+1);
          A.set(i, k, value);
        }
        i++;
      }
      con.close();
    }
    catch (SQLException ex)
    {
      println("Fatal error. Exception while performing SQL");
      println("Press any key to quit...");
      getKeyWait();
      System.exit(1);
    }

    println("Matrix A = ");
    A.print(12, 2);
    println("Press any key to quit...");
    getKeyWait();
    System.exit(0);
  }

  public static void main(String[] args)
  {
    new MatrixEx4();
  }
}