// MatrixEx5.java
// Write matrix to text file
// Can be read by Excel and saved as standard xls-file

import Jama.*;
import ch.aplu.util.Console;
import java.io.*;

public class MatrixEx5 extends Console
{
  final String filename = "matrix_A.xls";

  public MatrixEx5()
  {
    double[][] vals = {
        {1.0, 2.0, 3.0},
        {1.0, 3.0, 5.0},
        {1.0, 4.0, 6.0} };

    Matrix A = new Matrix(vals);

    PrintWriter out = null;
    try
    {
      File file = new File(filename);
      out = new PrintWriter(
        new BufferedWriter(new FileWriter(file)));
      A.print(out, 10, 2);
      println("File " + filename + " successfully written");
    }
    catch (Exception ex)
    {
      println("Fatal error. Exception while writing file");
      println("Press any key to quit...");
      getKeyWait();
      System.exit(1);
    }
    finally
    {
      if (out != null)
        out.close();
    }

    println("Press any key to quit...");
    getKeyWait();
    System.exit(0);
  }

  public static void main(String[] args)
  {
    new MatrixEx5();
  }
}