// PrintfEx4.java
// Harmonische Reihe 1 + 1/2 + 1/3 + ... divergiert.
// Berechne Anzahl Glieder,
// um eine bestimmte Teilsumme zu erreichen

import javax.swing.*;
import java.io.*;
import ch.aplu.util.*;

public class PrintfEx4
{
  private final int max_sum = 15;

  public PrintfEx4()
  {
    String filename = "harm.dat";
    String msg;
    PrintWriter out = null;
    try
    {
      out = new PrintWriter(
        new BufferedWriter(
          new FileWriter(new File(filename))));

      out.printf("   Teilsumme(sn)   Anzahl Glieder(n)" +
                 "      ln(n)          sn - ln(n)%n%n");

      LoResTimer timer = new LoResTimer(true);
      for (int sum = 2; sum <= max_sum; sum++)
      {
        double sn = 0;
        long n;
        for (n = 1; sn < sum; n++)
          sn = sn + 1.0 / n;
        out.printf("%15.6f%20d%15.6f%15.6f%n",
                   sn, n - 1,
                   Math.log(n-1), sn - Math.log(n-1));
      }

      timer.stop();
      msg =
        String.format("Datei %s erfolgreich geschrieben.\n" +
                      "Rechenzeit: %10.2f s",
                       filename, timer.getTime()/1E6);
    }
    catch (Exception ex)
    {
      msg = "Fatal error. Exception while writing file\n" +
             filename ;
    }

    if (out != null)
      out.close();

    JOptionPane.showMessageDialog(null, msg);
    System.exit(0);
  }

  public static void main(String[] args)
  {
    new PrintfEx4();
  }
}


/* Output in Datei harm.dat

   Teilsumme(sn)   Anzahl Glieder(n)      ln(n)          sn - ln(n)

       2.083333                   4       1.386294       0.697039
       3.019877                  11       2.397895       0.621982
       4.027245                  31       3.433987       0.593258
       5.002068                  83       4.418841       0.583228
       6.004367                 227       5.424950       0.579417
       7.001274                 616       6.423247       0.578027
       8.000486                1674       7.422971       0.577514
       9.000208                4550       8.422883       0.577326
      10.000043               12367       9.422787       0.577256
      11.000018               33617      10.422787       0.577231
      12.000003               91380      11.422782       0.577221
      13.000001              248397      12.422784       0.577218
      14.000001              675214      13.422785       0.577216
      15.000000             1835421      14.422784       0.577216
*/