// PropEx3.java

import ch.aplu.turtle.*;
import java.util.*;
import java.io.*;
import java.awt.geom.*;

public class PropEx3
{
  public PropEx3()
  {
    Properties prop = new Properties();
    open(prop, "turtle.properties");
    StringBuffer name = new StringBuffer();
    Point2D.Double startPos = new Point2D.Double();
    readProperties(prop, name, startPos);
    Turtle t = new Turtle();
    t.setPos(startPos);
    t.label("  " + name.toString());
    t.leftCircle(50);
  }

  private void readProperties(Properties prop,
                              StringBuffer name,
                              Point2D.Double start)
  {
    name.delete(0, name.length());
    name.append(prop.getProperty("turtle.name"));
    start.x = Integer.parseInt(
      prop.getProperty("turtle.startX").trim());
    start.y = Integer.parseInt(
      prop.getProperty("turtle.startY").trim());
  }

  private void open(Properties prop, String filename)
  {
    String msg = "";
    String fileUrl = "/" + filename;
    InputStream is = null;
    try
    {
      is = getClass().getResourceAsStream(fileUrl);
      if (is == null)
        throw new FileNotFoundException();
      prop.load(is);
    }
    catch (FileNotFoundException ex)
    {
      msg = "File " + filename + " not found";
    }
    catch (IOException ex)
    {
      msg = "Error reading " + filename;
    }
    if (is != null)
    {
      try
      {
        is.close();
      }
      catch (IOException ex) {}
    }
    if (!msg.equals(""))
    {
      System.err.println(msg);
      System.exit(1);
    }
  }

  public static void main(String[] args)
  {
    new PropEx3();
  }

}
