// GuiEx4.java

import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;

public class GuiEx4 extends JFrame
{
  private JPanel contentPane;
  private JTextArea jTextArea = new JTextArea(20, 30);
  private JScrollPane jScrollPane =
              new JScrollPane(jTextArea,
                              JScrollPane.
                              VERTICAL_SCROLLBAR_ALWAYS,
                              JScrollPane.
                              HORIZONTAL_SCROLLBAR_ALWAYS);

  public GuiEx4()
  {
    super("Primzahl-Fenster");
    setDefaultCloseOperation(WindowConstants.
                             EXIT_ON_CLOSE);
    init();
    pack();
    setVisible(true);

    for (int i = 1; i <= 30; i++)
    {
      String text;
      if (isPrime(i))
        text = " ist eine Primzahl\n";
      else
        text = " ist keine Primzahl\n";

      jTextArea.append(i + text);
      scrollToEnd();
    }
//    scrollToEnd();
  }

  private void init()
  {
    contentPane = (JPanel)getContentPane();
    contentPane.add(jScrollPane);
  }

  private boolean isPrime(int n)
  {
    for (int i = 2; i * i <= n; i++)
      if (n % i == 0)
        return false;
    return true;
  }

  private void scrollToEnd()
  {
    try
    {
      jTextArea.setCaretPosition(
          jTextArea.getLineEndOffset(
              jTextArea.getLineCount()-1));
    }
    catch (BadLocationException ex)
    {
      System.out.println(ex);
    }
  }

  public static void main(String[] args)
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new GuiEx4();
      }
    });
  }
}
