// ThreadEx5.java

import ch.aplu.util.*;
import javax.swing.JOptionPane;

class Receptionist
{
  private int bookId = 1;
  private int pencilId = 2;
  private boolean isBookAvailable = true;
  private boolean isPencilAvailable = true;

  public int getBook()
  {
    if (!isBookAvailable)
      return 0;
    isBookAvailable = false;
    return bookId;
  }

  public int getPencil()
  {
    if (!isPencilAvailable)
      return 0;
    isPencilAvailable = false;
    return pencilId;
  }

  public void setBook()
  {
    if (isBookAvailable)
    {
      JOptionPane.showMessageDialog(
        null, "Error: can't bring back book. Already here.");
      System.exit(0);
    }
    isBookAvailable = true;
  }

  public void setPencil()
  {
    if (isPencilAvailable)
    {
      JOptionPane.showMessageDialog(
        null,
        "Error: can't bring back pencil. Already here.");
      System.exit(0);
    }
    isPencilAvailable = true;
  }
}

class Guest extends Thread
{
  private Receptionist myReceptionist;

  Guest(Receptionist receptionist)
  {
    myReceptionist = receptionist;
  }

  public void run()
  {
    int bookId = 0, pencilId = 0;
    int count = 0;
    while (count < 2)
    {
      //      synchronized (myReceptionist)
      {
        while (bookId == 0 || pencilId == 0)
        {
          if (bookId == 0)
          {
            bookId = myReceptionist.getBook();
            if (bookId == 1)
              showMsg("Got book");
          }
          Console.delay(1000);
          if (pencilId == 0)
          {
            pencilId = myReceptionist.getPencil();
            if (pencilId == 2)
              showMsg("Got pencil");
          }
        }
        showMsg("Writing now...");
        Console.delay(1000);
        showMsg("Bring items back\n");
        myReceptionist.setBook();
        myReceptionist.setPencil();
        bookId = 0;
        pencilId = 0;
      }
      count++;
    }
  }

  private void showMsg(String msg)
  {
    System.out.print(getName() + " -> ");
    System.out.println(msg);
  }
}

public class ThreadEx5
{
  private Receptionist receptionist = new Receptionist();

  public ThreadEx5()
  {
    Guest p1 = new Guest(receptionist);
    Guest p2 = new Guest(receptionist);

    new Thread(p1).start();
    new Thread(p2).start();
  }

  public static void main(String[] args)
  {
    Console.init();
    new ThreadEx5();
  }
}
