// ThreadEx6.java

import ch.aplu.util.*;

class Data
{
  double[] value = new double[1000000];
  double sum;
}

class Init extends Thread
{
  private Data data;

  public Init(Data data)
  {
    this.data = data;
  }

  public void run()
  {
    synchronized (data)
    {
      System.out.println("Init in");
      data.sum = 0;
      for (int i = 0; i < 1000000; i++)
        data.value[i] = Math.sin(Math.PI / 2);
      System.out.println("Init out");
    }
  }
}

class Sum extends Thread
{
  private Data data;

  public Sum(Data data)
  {
    this.data = data;
  }

  public void run()
  {
    synchronized (data)
    {
      System.out.println("Sum in");
      for (int i = 0; i < 1000000; i++)
        data.sum += data.value[i];
    }
    System.out.println("Sum out");
  }
}

public class ThreadEx6
{
  private Data data = new Data();

  public ThreadEx6()
  {
    Init init = new Init(data);
    Sum sum = new Sum(data);

    init.start();
    sum.start();

    try
    {
      sum.join();
    }
    catch (InterruptedException ex) {}

    System.out.println("Summe: " + data.sum);
  }

  public static void main(String[] args)
  {
    Console.init();
    new ThreadEx6();
  }
}
