// ChatServer.java

import java.awt.EventQueue;
import java.net.*;
import java.io.*;

public class ChatServer
{
  class InputThread extends Thread
  {
    public void run()
    {
      try
      {
        while (true)
          line = netIn.readLine(); // Blocking
      }
      catch (IOException ex)
      {
        p.appendLine("Connection lost");
        isConnected = false;
      }
    }
  }

  private static int nbConnections = 1;
  private BufferedReader netIn = null;
  private PrintWriter netOut = null;
  private String line = null;
  private boolean isConnected = false;
  private ChatPanel p;

  public ChatServer(int port)
  {
    // Create ChatPanel in EDT
    try
    {
      EventQueue.invokeAndWait(new Runnable()
      {
        public void run()
        {
          p = new ChatPanel("Simple Chat (Server)");
        }
      });
    }
    catch (Exception ex) {}

    try
    {
      ServerSocket server = new ServerSocket(port,
                                             nbConnections);
      while (true)
      {
        p.appendLine("Waiting for client on port " + port);
        Socket socket = server.accept(); // Blocking
        isConnected = true;
        p.enableEntry(true);

        netIn = new BufferedReader(
          new InputStreamReader(socket.getInputStream()));
        netOut = new PrintWriter(
          new OutputStreamWriter(socket.getOutputStream()));

        p.setOutput(netOut);
        p.appendLine("Connected to " +
                     socket.getInetAddress());

        new InputThread().start();

        while (isConnected)
        {
          try
          {
            Thread.currentThread().sleep(1);
          }
          catch (InterruptedException ex) {}
          if (line != null)
          {
            p.appendLine(line);
            line = null;
          }
        }
        p.enableEntry(false);
        netIn.close();
        netOut.close();
        socket.close();
      }
    }
    catch (BindException ex)
    {
      p.appendLine("Service already running on port " + port);
    }
    catch (IOException ex)
    {
      p.appendLine("Error " + ex);
    }
  }

  public static void main(String args[])
  {
    int port = 3000;
    if (args.length > 0)
      port = Integer.parseInt(args[0]);
    new ChatServer(port);
  }
}
