// LptPortEx2.java

import ch.aplu.util.*;

class LptPortEx2 extends Console implements ExitListener
{
  LptPort lpt1 = new LptPort();
  int baseAddress = 0x3BC;

  LptPortEx2()
  {
    System.loadLibrary("jlptport");
    print("Opening parallel port now... ");

    addExitListener(this);

    int rc = lpt1.open(baseAddress);
    if (rc == 0)
      println("ok");
    else
    {
      println("failed");
      return;
    }

    while (true)
    {
      print("\nEnter a byte: ");
      int outdata = readInt();
      println("Write it to data port...");
      lpt1.writeData(outdata);

      println("Write it to control port...");
      lpt1.writeControl(outdata);

      int indata = lpt1.readData();
      println("Got from data port: " + indata);

      int status = lpt1.readStatus();
      println("Got from status port: " + status);
    }
  }

  public void notifyExit()
  {
    lpt1.close();
    System.exit(0);
  }

  public static void main(String[] args)
  {
    new LptPortEx2();
  }
}
