// StreamingBufferPlayer.java

import javax.sound.sampled.*;
import java.io.*;

class StreamingBufferPlayer extends StreamingPlayer
{
  public StreamingBufferPlayer(AudioFormat audioFormat)
  {
    this.audioFormat = audioFormat;
  }

  public void start(
          ByteArrayOutputStream data, boolean doFinish)
            throws LineUnavailableException
  {
    byte[] audioData = data.toByteArray();
    InputStream byteArrayInputStream =
      new ByteArrayInputStream(audioData);
    audioInputStream =
      new AudioInputStream(byteArrayInputStream, audioFormat,
                           audioData.length /
                           audioFormat.getFrameSize());
    start(doFinish);
  }
}
