// GraphicsEx6.java

import java.awt.*;
import java.util.*;
import java.awt.event.*;

public class GraphicsEx6 extends Frame
{
  private int width = 500;
  private int height = 500;
  private int maxNbPoints = 50000;

  public GraphicsEx6()
  {
    addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent evt)
      {
        System.exit(0);
      }
    });

    Farn farn = new Farn(width, height);
    add(farn);
    setResizable(false);
    pack();
    setVisible(true);

    int nbPoints;
    int oldNbPoints = -1;
    long time = new Date().getTime();
    while ((nbPoints = farn.getNbPoints()) < maxNbPoints)
    {
      if (nbPoints != oldNbPoints)
      {
        farn.repaint();
        oldNbPoints = nbPoints;
      }
      Thread.currentThread().yield();
    }
    time = new Date().getTime() - time;
    System.out.println("All done after " + time + " ms");
  }

  public static void main(String[] args)
  {
    new GraphicsEx6();
  }

}
