// Buffon.java

import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import javax.swing.*;

public class Buffon extends JPanel
{
  private BufferedImage bi;
  private Graphics2D offG2D;
  private int width, height;
  private int nbNeedles = 0;
  private int nbHits = 0;
  private Color bkColor = Color.white;
  private int d; // Length of needles
  private Line2D.Double[] lines = new Line2D.Double[2];

  public Buffon(int width, int height)
  {
    this.width = width;
    this.height = height;
    d = height / 2;
    bi = new BufferedImage(width, height,
                           BufferedImage.TYPE_INT_RGB);
    offG2D = bi.createGraphics();
    setPreferredSize(new Dimension(width, height));
    offG2D.setColor(bkColor);
    offG2D.fillRect(0, 0, width, height);
    lines[0] = new Line2D.Double(0, d / 2, width, d / 2);
    lines[1] = new Line2D.Double(0, 3 * d / 2, width,
                                 3 * d / 2);
    offG2D.setColor(Color.black);
    BasicStroke stroke = new BasicStroke(2);
    offG2D.setStroke(stroke);
    offG2D.draw(lines[0]);
    offG2D.draw(lines[1]);
    stroke = new BasicStroke(1);
    offG2D.setStroke(stroke);
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    g.drawImage(bi, 0, 0, null);
  }

  public int getNbNeedles()
  {
    return nbNeedles;
  }

  public int getNbHits()
  {
    return nbHits;
  }

  public void throwNeedle()
  {
    double xm = (width - d) * Math.random() + d / 2;
    double ym = height * Math.random();
    double theta = Math.PI * Math.random();
    double x2 = xm + d / 2 * Math.cos(theta);
    double y2 = ym + d / 2 * Math.sin(theta);
    double x1 = xm - d / 2 * Math.cos(theta);
    double y1 = ym - d / 2 * Math.sin(theta);
    Line2D.Double needle = new Line2D.Double(x1, y1, x2, y2);
    if (needle.intersectsLine(lines[0])
            || needle.intersectsLine(lines[1]))
    {
      nbHits++;
      offG2D.setColor(Color.green);
    }
    else
      offG2D.setColor(Color.red);
    offG2D.draw(needle);
    Rectangle r = needle.getBounds();
    repaint(r.x, r.y, r.width, r.height);
    nbNeedles++;
  }
}
