// Man.java

import java.awt.*;

public class Man extends Canvas
{
  private Image image;
  private int xPos, yPos;

  public Man(String imagePath, int x, int y)
  {
    image = loadImage(imagePath);
    xPos = x;
    yPos = y;
    setBackground(Color.cyan);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(400, 400);
  }

  public void paint(Graphics g)
  {
    super.paint(g);
    Graphics2D g2D = (Graphics2D)g;
    g2D.drawImage(image, xPos, yPos, null);
  }

  public void setPos(int x, int y)
  {
    xPos = x;
    yPos = y;
  }

  public Image loadImage(String imagePath)
  {
    Image image =
      Toolkit.getDefaultToolkit().getImage(imagePath);
    MediaTracker mt = new MediaTracker(this);
    mt.addImage(image, 1);
    try
    {
      mt.waitForAll();
    }
    catch (Exception ex)
    {
      System.out.println("Exception while loading image.");
    }
    return image;
  }
}
