// PrettyTriangle.java

import java.awt.*;
import java.awt.geom.*;

public class PrettyTriangle
{
  private GeneralPath genPath = new GeneralPath();
  private GradientPaint gradPaint;

  public PrettyTriangle(Point2D.Float[] corners,
                        GradientPaint gradientPaint)
  {
    genPath.moveTo(corners[0].x, corners[0].y);
    genPath.lineTo(corners[1].x, corners[1].y);
    genPath.lineTo(corners[2].x, corners[2].y);
    genPath.closePath();
    gradPaint = gradientPaint;
  }

  public void show(Graphics2D g2D)
  {
    g2D.setPaint(gradPaint);
    g2D.fill(genPath);
  }
}
