// XmlReader.java

import java.applet.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import ch.aplu.util.*;
import java.net.*;
import java.io.*;

public class XmlReader extends JApplet
{
  private String filename = "persons.xml";
  private boolean isStandalone = false;
  private int width;
  private int height;
  private String[] colNames = {"Nachname", "Vorname",
                               "Geschlecht", "Alter"};

  public String getParameter(String key, String def)
  {
    return isStandalone
           ? System.getProperty(key, def)
           : (getParameter(key) != null
              ? getParameter(key) : def);
  }

  public void init()
  {
    width = Integer.parseInt(getParameter("width", "400"));
    height = Integer.parseInt(getParameter("height", "100"));
    MySAXParser msp = new MySAXParser();
    try
    {
      //    URL url = new URL(
      //    "http://www.aplu.ch/applets/xml/" + filename);
      URL url = new File("c:/" + filename).toURL();
      Object data[][] = msp.processURL(url);
      JTable table = new JTable(data, colNames);
      table.setPreferredScrollableViewportSize(
        new Dimension(width, height));
      getContentPane().add(new JScrollPane(table));
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public void initStandalone()
  {
    init();
    JFrame f = new JFrame();
    f.setContentPane(getContentPane());
    f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    f.pack();
    f.setVisible(true);
  }

  public static void main(String args[])
  {
   EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        XmlReader xr = new XmlReader();
        xr.isStandalone = true;
        xr.initStandalone();
      }
    });
  }
}
