// BouncingBall.java

import java.awt.*;
import javax.swing.*;
import ch.aplu.util.*;

public class BouncingBall extends JApplet implements Runnable
{
  private GPane p;
  private volatile boolean active = true;

  public void start()
  {
    p = new GPane();
    p.window(0, 500, 0, 40);
    p.enableRepaint(false);
    getContentPane().add(p);
    new Thread(this).start();
  }

  public void run()
  {
    double r = 20;
    double x = r;
    double y = r;
    double dx = 2;
    while (active)
    {
      p.color(Color.black);
      p.move(250, 20);
      p.rectangle(500, 40);
      p.color(Color.red);
      p.move(x, y);
      p.fillCircle(r);
      p.repaint();
      Console.delay(50);
      p.clear();
      if (x > 500 - r || x < r)
        dx = -dx;
      x += dx;
    }
  }

  public void stop()
  {
    p.dispose();
    active = false;
  }
}
