// MousePanel.java

import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;
import ch.aplu.util.*;

public class MousePanel extends GPane
{
  private Point2D.Double anchor;
  private Point2D.Double pt;

  private class MyMouseInputAdapter extends MouseInputAdapter
  {
    public void mousePressed(MouseEvent evt)
    {
      setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
      anchor = pt = toWindow(evt.getPoint());
    }

    public void mouseReleased(MouseEvent evt)
    {
      setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
      setPaintMode();
      color(Color.black);
      line(anchor, pt); // Draw definitely
    }

    public void mouseDragged(MouseEvent evt)
    {
      color(Color.red);
      setXORMode(Color.white);
      line(anchor, pt); // Erase line
      pt = toWindow(evt.getPoint());
      line(anchor, pt); // Draw line
    }
  }

  public MousePanel()
  {
    MyMouseInputAdapter mia = new MyMouseInputAdapter();
    addMouseListener(mia);
    addMouseMotionListener(mia);
  }
}
