// Population.java

import java.util.*;

public class Population
{
  private boolean[] pop;
  private int nbPop;
  private int nbGen;
  private int nbSick;

  public Population(int nbPop, int nbSick)
  {
    this.nbPop = nbPop;
    this.nbSick = nbSick;
    nbGen = 0;
    pop = new boolean[nbPop];
    initialize(nbSick);
  }

  public String getPopDescription()
  {
    String s = "";
    for (int i = 0; i < nbPop; i++)
      if (pop[i])
        s = s + "x";
      else
        s = s + "o";
    return s + "\n";
  }

  public String getPopStatus()
  {
    String s = nbGen + ". Generation: " + nbSick + " (of " +
               nbPop + ") krank";
    return s;
  }

  public int getGen()
  {
    return nbGen;
  }

  public int getSick()
  {
    return nbSick;
  }

  public void nextGen()
  {
    Random rnd = new Random();
    int m = 0;
    int n = 0;
    do
    {
      m = rnd.nextInt(nbPop);
      n = rnd.nextInt(nbPop);
    }
    while (m == n);
    if (pop[m] != pop[n])
    {
      nbSick++;
      pop[m] = pop[n] = true;
    }
    nbGen++;
  }

  public void initialize(int nbSick)
  {
    for (int i = 0; i < nbPop; i++)
      pop[i] = false;
    Random rnd = new Random();
    int z = 0;
    while (z != nbSick)
    {
      int i = rnd.nextInt(nbPop);
      if (!pop[i]) // not yet sick
      {
        z++;
        pop[i] = true;
      }
    }
  }
}
