// ReflectEx4.java

import java.lang.reflect.*;
import ch.aplu.util.*;

public class ReflectEx4 extends Console
{
  public ReflectEx4() throws Exception
  {
    // Load class, who's name is known at run-time only
    print("Gebe den Namen der Klasse ein: ");
    String classname = Console.readLine();
    Class c = Class.forName(classname);

    // Instantiate a new object, so we can use it's methods
    Object obj = c.newInstance();

    // Invoke a method with empty parameter list
    Method whoMethod = c.getMethod("who", new Class[]{});
    whoMethod.invoke(obj, new Object[]{});

    // Invoke method who's name is known at run-time only
    print("Gebe den Namen der Methode ein: ");
    String methodname = readLine();
    print("Erster Faktor? ");
    int m = Console.readInt();
    print("Zweiter Faktor? ");
    int n = readInt();
    Class[] argTypes = new Class[]{int.class, int.class};
    Method method = c.getMethod(methodname, argTypes);
    Object[] argValues = new Object[]{new Integer(m),
                                      new Integer(n)};
    Integer k = (Integer)method.invoke(obj, argValues);
    println(methodname + "(" + m + "," + n + ") = " + k);
  }

  public static void main(String[] args) throws Exception
  {
    new ReflectEx4();
  }
}
