// FibClient.java
// Create stub using rmic before execution

import java.rmi.*;
import java.rmi.registry.*;
import ch.aplu.util.*;

public class FibClient extends Console
{
  private static String host;
  private final static int port = 1099; // Default RMI port

  public FibClient()
  {
    print("Host: ");
    host = readLine();
    try
    {
      FibIf fib;
      println("Trying to get RMI services from\n" + host +
              " on port " + port + "...");
      Registry reg = LocateRegistry.getRegistry(host, port);
      fib = (FibIf)reg.lookup("Fibonacci");
      println("Connected at : " + fib.getServerDate());

      while (true)
      {
        print("Welches Glied der Fibonacci-Folge? ");
        Integer nb = getInt();
        if (nb != null)
        {
          long value = fib.getFib(nb.intValue());
          println("Wert: " + value);
        }
        else
          println("Falsche Eingabe");
      }
    }
    catch (Exception ex)
    {
      println("FibClient exception: " + ex);
    }
  }

  public static void main(String args[])
  {
    new FibClient();
  }
}
