// ServletEx2.java

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class ServletEx2 extends HttpServlet
{
  private final String version = "1.0";
  private static final String CONTENT_TYPE = "text/html";
  private final int nbGames = 1000;
  private int nbSpots = 0;

  public void doGet(
          HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException
  {
    String nbSpotsStr = request.getParameter("param");
    if (nbSpotsStr == null)
    {
      makeHtmlResponse(response, -2);
      return;
    }
    try
    {
      nbSpots = Integer.parseInt(nbSpotsStr);
    }
    catch (NumberFormatException ex)
    {
      makeHtmlResponse(response, -1);
      return;
    }

    Dice dice = new Dice();
    int hits = 0;
    for (int i = 0; i < nbGames; i++)
      if (dice.doThrow() + dice.doThrow() == nbSpots)
        hits++;
    makeHtmlResponse(response, hits);
  }

  void makeHtmlResponse(
          HttpServletResponse response, int nbHits)
            throws IOException
  {
    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>ServletEx2</title></head>");
    out.println("<body>");
    out.println("<h1>ServletEx2 Version " + version +
                "</h1><br>");

    if (nbHits < 0)
      out.println("Fehlerhafter oder fehlender Parameter");
    else
      out.println("Bei " + nbGames +
                  " Doppelwuerfen wurde die Augensumme " +
                  nbSpots + " " + nbHits + "x getroffen");
    out.println("</body></html>");
  }
}

class Dice
{
  public int doThrow()
  {
    return (int)(6 * Math.random()) + 1;
  }
}
